osg::DrawArrays Class Reference

`#include <PrimitiveSet>`

Inheritance diagram for osg::DrawArrays:

## Public Member Functions

| DrawArrays (GLenum mode=0)
| DrawArrays (GLenum mode, GLint first, GLsizei count, int numInstances=0)
| DrawArrays (const DrawArrays &da, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
void | set (GLenum mode, GLint first, GLsizei count)
void | setFirst (GLint first)
GLint | getFirst () const
void | setCount (GLsizei count)
GLsizei | getCount () const
virtual void | draw (State &state, bool useVertexBufferObjects) const
virtual void | accept (PrimitiveFunctor &functor) const
virtual void | accept (PrimitiveIndexFunctor &functor) const
virtual unsigned int | getNumIndices () const
virtual unsigned int | index (unsigned int pos) const
virtual void | offsetIndices (int offset)
Public Member Functions inherited from osg::PrimitiveSet
| PrimitiveSet (Type primType=PrimitiveType, GLenum mode=0, int numInstances=0)
| PrimitiveSet (const PrimitiveSet &prim, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
Type | getType () const
virtual osg::PrimitiveSet * | asPrimitiveSet ()
virtual const osg::PrimitiveSet * | asPrimitiveSet () const
virtual const GLvoid * | getDataPointer () const
virtual unsigned int | getTotalDataSize () const
virtual bool | supportsBufferObject () const
virtual DrawElements * | getDrawElements ()
virtual const DrawElements * | getDrawElements () const
void | setNumInstances (int n)
int | getNumInstances () const
void | setMode (GLenum mode)
GLenum | getMode () const
virtual unsigned int | getNumPrimitives () const
virtual void | computeRange () const
Public Member Functions inherited from osg::BufferData
| BufferData ()
| BufferData (const BufferData &bd, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual osg::Array * | asArray ()
virtual const osg::Array * | asArray () const
virtual osg::Image * | asImage ()
virtual const osg::Image * | asImage () const
void | setBufferObject (BufferObject *bufferObject)
BufferObject * | getBufferObject ()
const BufferObject * | getBufferObject () const
void | setBufferIndex (unsigned int index)
unsigned int | getBufferIndex () const
GLBufferObject * | getGLBufferObject (unsigned int contextID) const
GLBufferObject * | getOrCreateGLBufferObject (unsigned int contextID) const
void | setModifiedCallback (ModifiedCallback *md)
ModifiedCallback * | getModifiedCallback ()
const ModifiedCallback * | getModifiedCallback () const
void | dirty ()
void | setModifiedCount (unsigned int value)
unsigned int | getModifiedCount () const
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
void | releaseGLObjects (State *state=0) const
unsigned int | getNumClients () const
void | addClient (osg::Object *)
void | removeClient (osg::Object *)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~DrawArrays ()
Protected Member Functions inherited from osg::PrimitiveSet
virtual | ~PrimitiveSet ()
Protected Member Functions inherited from osg::BufferData
virtual | ~BufferData ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

GLint | _first
GLsizei | _count
Protected Attributes inherited from osg::PrimitiveSet
Type | _primitiveType
int | _numInstances
GLenum | _mode
Protected Attributes inherited from osg::BufferData
unsigned int | _modifiedCount
unsigned int | _bufferIndex
osg::ref_ptr< BufferObject > | _bufferObject
osg::ref_ptr< ModifiedCallback > | _modifiedCallback
unsigned int | _numClients
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::PrimitiveSet

enum

Type {
PrimitiveType , DrawArraysPrimitiveType , DrawArrayLengthsPrimitiveType , DrawElementsUBytePrimitiveType ,
DrawElementsUShortPrimitiveType , DrawElementsUIntPrimitiveType , MultiDrawArraysPrimitiveType , DrawArraysIndirectPrimitiveType ,
DrawElementsUByteIndirectPrimitiveType , DrawElementsUShortIndirectPrimitiveType , DrawElementsUIntIndirectPrimitiveType , MultiDrawArraysIndirectPrimitiveType ,
MultiDrawElementsUByteIndirectPrimitiveType , MultiDrawElementsUShortIndirectPrimitiveType , MultiDrawElementsUIntIndirectPrimitiveType
}

enum

Mode {
POINTS = GL_POINTS , LINES = GL_LINES , LINE_STRIP = GL_LINE_STRIP , LINE_LOOP = GL_LINE_LOOP ,
TRIANGLES = GL_TRIANGLES , TRIANGLE_STRIP = GL_TRIANGLE_STRIP , TRIANGLE_FAN = GL_TRIANGLE_FAN , QUADS = GL_QUADS ,
QUAD_STRIP = GL_QUAD_STRIP , POLYGON = GL_POLYGON , LINES_ADJACENCY = GL_LINES_ADJACENCY , LINE_STRIP_ADJACENCY = GL_LINE_STRIP_ADJACENCY ,
TRIANGLES_ADJACENCY = GL_TRIANGLES_ADJACENCY , TRIANGLE_STRIP_ADJACENCY = GL_TRIANGLE_STRIP_ADJACENCY , PATCHES = GL_PATCHES
}

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## DrawArrays() [1/3]

osg::DrawArrays::DrawArrays | ( | GLenum | mode = 0 | ) |

inline

References _count, _first, osg::PrimitiveSet::DrawArraysPrimitiveType, and osg::PrimitiveSet::PrimitiveSet().

Referenced by clone(), cloneType(), DrawArrays(), and isSameKindAs().

## DrawArrays() [2/3]

osg::DrawArrays::DrawArrays | ( | GLenum | mode,
|  | GLint | first,
|  | GLsizei | count,
|  | int | numInstances = 0 )

inline

References _count, _first, osg::PrimitiveSet::DrawArraysPrimitiveType, and osg::PrimitiveSet::PrimitiveSet().

## DrawArrays() [3/3]

osg::DrawArrays::DrawArrays | ( | const DrawArrays & | da,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

References _count, _first, DrawArrays(), osg::PrimitiveSet::PrimitiveSet(), and osg::CopyOp::SHALLOW_COPY.

## ~DrawArrays()

virtual osg::DrawArrays::~DrawArrays | ( |  | ) |

inline protected virtual

## Member Function Documentation

## accept() [1/2]

virtual void osg::DrawArrays::accept | ( | PrimitiveFunctor & | functor | ) | const

virtual

Implements osg::PrimitiveSet.

## accept() [2/2]

virtual void osg::DrawArrays::accept | ( | PrimitiveIndexFunctor & | functor | ) | const

virtual

Implements osg::PrimitiveSet.

## className()

virtual const char * osg::DrawArrays::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Reimplemented from osg::PrimitiveSet.

## clone()

virtual Object * osg::DrawArrays::clone | ( | const CopyOp & |  | ) | const

inline virtual

Clone an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References DrawArrays().

## cloneType()

virtual Object * osg::DrawArrays::cloneType | ( |  | ) | const

inline virtual

Clone the type of an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References DrawArrays().

## draw()

virtual void osg::DrawArrays::draw | ( | State & | state,
|  | bool | useVertexBufferObjects ) const

virtual

Implements osg::PrimitiveSet.

## getCount()

GLsizei osg::DrawArrays::getCount | ( |  | ) | const

inline

References _count.

## getFirst()

GLint osg::DrawArrays::getFirst | ( |  | ) | const

inline

References _first.

## getNumIndices()

virtual unsigned int osg::DrawArrays::getNumIndices | ( |  | ) | const

inline virtual

Implements osg::PrimitiveSet.

References _count.

## index()

virtual unsigned int osg::DrawArrays::index | ( | unsigned int | pos | ) | const

inline virtual

Implements osg::PrimitiveSet.

References _first.

## isSameKindAs()

virtual bool osg::DrawArrays::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

Reimplemented from osg::PrimitiveSet.

References DrawArrays(), and NULL.

## libraryName()

virtual const char * osg::DrawArrays::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Reimplemented from osg::PrimitiveSet.

## offsetIndices()

virtual void osg::DrawArrays::offsetIndices | ( | int | offset | ) |

inline virtual

Implements osg::PrimitiveSet.

References _first.

## set()

void osg::DrawArrays::set | ( | GLenum | mode,
|  | GLint | first,
|  | GLsizei | count )

inline

References _count, _first, and osg::PrimitiveSet::_mode.

## setCount()

void osg::DrawArrays::setCount | ( | GLsizei | count | ) |

inline

References _count.

## setFirst()

void osg::DrawArrays::setFirst | ( | GLint | first | ) |

inline

References _first.

## Member Data Documentation

## _count

GLsizei osg::DrawArrays::_count

protected

Referenced by DrawArrays(), DrawArrays(), DrawArrays(), getCount(), getNumIndices(), set(), and setCount().

## _first

GLint osg::DrawArrays::_first

protected

Referenced by DrawArrays(), DrawArrays(), DrawArrays(), getFirst(), index(), offsetIndices(), set(), and setFirst().

The documentation for this class was generated from the following file:

- PrimitiveSet